/*
 * Jacek Łysiak <jl345639@students.mimuw.edu.pl>
 *
 * Latte compiler.
 */
#ifndef __LATTE_COMPILER__
#define __LATTE_COMPILER__

#include <latte/latte/Absyn.h>	// File generated by BNFC	

#include <latte/error.h>
#include <latte/common/Logger.h>
#include <latte/common/Environment.h>

class Compiler
{
public:
	Compiler(FILE *input, std::ostream& output, Common::Logger &logger);
	void compile();
	err_t status() const;

private:
	err_t _status;
	FILE *_input;
	std::ostream& _output;
	Common::Logger &_logger;

	Latte::Program *_ast_root;
	Common::Environment _env;
	//Backend::CodeGenerator &_backend;
	
};

#endif // __LATTE_COMPILER__
